package com.syjy.calculate.function;

import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.runtime.function.AbstractFunction;
import com.googlecode.aviator.runtime.type.AviatorDecimal;
import com.googlecode.aviator.runtime.type.AviatorObject;
import com.googlecode.aviator.runtime.type.Sequence;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * 计算准确率 :平均绝对误差
 *
 * @author zcl
 * @version 1.0
 * @since 2022/9/8 9:30
 */
public class MeanAbsoluteError extends AbstractFunction {
    @Override
    public AviatorObject call(Map<String, Object> env, AviatorObject arg1) {
        // 获取参数
        Object first = arg1.getValue(env);
        // 将参数转为集合
        Sequence seq = CommonUtil.getSeq(first,env);
        // 获取Σ|实际-预测|
        BigDecimal sumDifferenceAbsolute = new BigDecimal(String.valueOf(AviatorEvaluator.execute("sumDifferenceAbsolute(list)",env)));
        // 获取容量
        BigDecimal electricCapacity = (BigDecimal)env.get("electricCapacity");
        BigDecimal size = new BigDecimal(seq.hintSize());
        Map<String ,Object> map = new HashMap<>();
        map.put("electricCapacity",electricCapacity);
        map.put("sumDifferenceAbsolute",sumDifferenceAbsolute);
        map.put("size",size);
        // 计算 1-(Σ|实际-预测|/cap*n)
        BigDecimal result = new BigDecimal(String.valueOf(AviatorEvaluator.execute("1-(sumDifferenceAbsolute/(electricCapacity*size))",map))) ;
        // 返回结果
        return new AviatorDecimal(result);
    }
    @Override
    public String getName() {
        return "meanAbsoluteError";
    }
}
